// Clase DateTime provee al programador una forma sencilla de operar con fechas y hora.
// Copyright (C) Gammexane
// Gammexane@Yahoo.com.ar

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


#ifndef _CDATETIME_H
#define _CDETETIME_H

#include <iostream>
#include <string>
#include <algorithm>

using namespace std;

/*******************************************************************************************
*                              Clase para manipulacion de Fechas
*******************************************************************************************/
typedef enum {DD=0, MM, AAAA, AA} DComp; 
typedef enum {LN, LNG} DLComp;

class cldate{

	public:
	    cldate();
	    cldate(const char*);
		cldate& operator =(int);
		cldate& operator =(const cldate&);
		cldate& operator =(const string&);		
		cldate& operator++();
		cldate& operator--();
		    
		string gregoriano()const;                 // devuelve la fecha en Gregoriano
		int    juliano() const {return _date;}    // devuelve el valor en Juliano
		string format(DComp, DComp, DComp) const; // Formato Corto
		string format(DLComp) const;              // Formato largo
		~cldate(){};		
	private:
		typedef struct{
			short day, month, year;
		}STdate;
		int   _date;
		char  _SEP;
		STdate split(string)const;
};

cldate   operator+ (const cldate&, int);
cldate   operator- (const cldate&, int);
int      operator- (const cldate&, const cldate&); 
ostream& operator<<(ostream&, const cldate&);
istream& operator>>(istream&, cldate&);

/*******************************************************************************************
*                              Clase para manipulacion de tiempo
*******************************************************************************************/
typedef struct{
	int hour, min, sec;
}STtime;

class cltime{

	public:
		cltime();
		cltime(string);
		cltime& operator =(int);
		cltime& operator =(const cltime&);
		cltime& operator =(const string&);
		cltime& operator++();
		cltime& operator--();
			
		int    seconds() const {return _time;} // devuelve el tiempo en segundos.
		string hours()   const;                // devuelve el tiempo en horas, min y seg. 
		~cltime(){};
	private:
		char _SEP;
		int  _time;
};

ostream& operator<<(ostream&, const cltime&);
istream& operator>>(istream&, cltime&);

#endif
